/***************************************************************************
 *   Copyright (C) 2007 by    *
 *      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "abi_gun_vacuum_vlv.h"
#include <qtango.h>

abi_gun_vacuum_vlv::abi_gun_vacuum_vlv(QWidget *parent) : QWidget(parent)
{
	QSettings settings("fermi", "acs");
	// load (or set) path for images
	if (settings.contains("imgpath")) {
		imgpath = settings.value("imgpath").toString();
		// cout << imgpath.toStdString() << endl;
	}
	else {
		settings.setValue("imgpath", "/runtime/fermi/share/images/acs");
		// settings.setValue("imgpath", "/home/zambonl/devel/qt/fermi/acs/img");
	}
	if (!imgpath.endsWith("/")) {
		imgpath = imgpath + "/";
	}
	// setup User Interface
	ui.setupUi(this);

	try {
		connect(ui.legendButton, SIGNAL(clicked()), this, SLOT(open_legend()));
		legend_process = new QProcess(this);
	}
	catch (const Tango::DevFailed &e) {
		cout << "cannot connect UI buttons" << endl;
	}
	catch (...) {
		cout << "default exception, cannot setup UI" << endl;
	}	
	line_config(ui.line_linac1_1);
	line_config(ui.line_linac2_1);
	line_config(ui.line_linac2_2);
	line_config(ui.line_linac2_3);
	line_config(ui.line_linac3_1);
	line_config(ui.line_linac3_2);
	line_config(ui.line_linac3_3);
	line_config(ui.line_linac4_1);
	line_config(ui.line_linac4_2);
	line_config(ui.line_linac4_3);
	line_config(ui.line_linac6_1);
	line_config(ui.line_linac6_2);
	line_config(ui.line_linac6_3);
	line_config(ui.line_linac6_4);
	line_config(ui.line_linac6_5);
	line_config(ui.line_linac6_6);
	line_config(ui.line_linac6_7);
	line_config(ui.line_linac7_1);
	line_config(ui.line_undulator3_1);
	line_config(ui.line_undulator3_2);
	line_config(ui.line_undulator3_3);
	line_config(ui.line_undulator3_4);
	line_config(ui.line_undulator3_5);
	line_config(ui.line_undulator3_6);
	line_config(ui.line_undulator3_7);
	line_config(ui.line_undulator4_1);
	line_config(ui.line_undulator4_2);
	line_config(ui.line_undulator4_3);
	line_config(ui.line_undulator4_4);
	line_config(ui.line_undulator4_5);
	line_config(ui.line_undulator4_6);
	line_config(ui.line_undulator4_7);
	line_config(ui.line_padres1_1);
	line_config(ui.line_padres1_2);
	line_config(ui.line_padres1_3);
	line_config(ui.line_padres2_1);
	line_config(ui.line_padres2_2);
	line_config(ui.line_padres2_3);
	line_config(ui.line_padres3_1);
	line_config(ui.line_padres3_2);
	line_config(ui.line_padres3_3);
	line_config(ui.line_padres4_1);
}

abi_gun_vacuum_vlv::~abi_gun_vacuum_vlv()
{
	exit(0);
}    


void abi_gun_vacuum_vlv::line_config(TTable *line)
{
	ELabel *childLabel = line->findChild<ELabel *>();
	if(childLabel) {
		childLabel->setFrameShape(QFrame::NoFrame);
		line->setBooleanDisplay(0, "", "", "#DC0000", "#00C800");
	}	
}

void abi_gun_vacuum_vlv::open_legend()
{
	if (legend_process->state() == QProcess::Running) {
		legend_process->kill();
		legend_process->waitForFinished(3000);			
	}	
	legend_process->start("abi_gun_vacuum_vlv_legend");
}
